# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) 2019-present GeminiTeam ihad.tv (http://ihad.tv)

import os, fcntl
import struct
from vfdutils import *

TM1628_IOC_BRIGHT = ord('S') << (4*2) | 1

class VfdDev:
	def __init__(self):
		import ioctl
		import ctypes
		size = ctypes.sizeof(ctypes.c_int(0))
		self._TM1628_IOC_MAGIC = ord('S')
		self._TM1628_IOC_POWER = ioctl.IOW(self._TM1628_IOC_MAGIC,  0, size)
		self._TM1628_IOC_SBRIGHT = ioctl.IOW(self._TM1628_IOC_MAGIC,  1, size)
		#self._TM1628_IOC_GBRIGHT = ioctl.IOR(self._TM1628_IOC_MAGIC,  4, size)
		self._TM1628_IOC_MAXNR = 4

	def enableDisplay(self, value):
		self.__writeTM1628(self._TM1628_IOC_POWER, int(value))

	#def getBrightness(self):
	#	return self.__readTM1628(self._TM1628_IOC_GBRIGHT)

	def setBrightness(self, value):
		self.__writeTM1628(self._TM1628_IOC_SBRIGHT, value)

	#def __readTM1628(self, cmd, isBuf = False):
	#	import ioctl
	#	ret = None
	#	if (ioctl.DIR(cmd) == ioctl.READ and self.__writeTM1628(cmd, 0)):
	#		with open("/dev/vfd", "rb") as vfd:
	#			ret = vfd.read()
	#		if (ret == ''):
	#			ret = None
	#		if (not isBuf and ret != None):
	#			ret = int(ret, 0)
	#	kodiLog('VfdDev.__readTM1628: value = {0}'.format(str(ret)))
	#	return ret

	def __writeTM1628(self, cmd, value, isBuf = False):
		ret = False
		if (os.path.exists("/dev/vfd")):
			if isBuf:
				value = ''.join([struct.pack('I', cmd), value])
			else:
				value = struct.pack('i', value)
			kodiLog('VfdDev.__writeTM1628: value = {0}'.format(repr(value)))
			try:
				with open("/dev/vfd", "wb") as vfd:
					fcntl.ioctl( vfd, cmd, value )
				ret = True
			except Exception as inst:
				kodiLogError(inst)
		return ret
