# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright (C) 2019-present GeminiTeam ihad.tv (http://ihad.tv)

import xbmcaddon

addon = xbmcaddon.Addon(id="service.vfd")

def getSetting(id):
	return addon.getSetting(id)

def getSettingBool(id):
	value = getSetting(id).lower()
	if (value == "true"):
		value = True
	else:
		value = False
	return value

def getSettingInt(id):
	return int(getSetting(id))

def getSettingNumber(id):
	return float(getSetting(id))

class VfdSettings:
	def __init__(self):
		self.readValues()

	def isDisplayOn(self):
		return self._displayOn

	def getBrightness(self):
		return self._displayBrightness
	
	def isChannelOn(self):
		return self._displayChannelOn
	
	def getChannelTimeout(self):
		return self._displayChannelTimeout
	
	def isPlaytimeOn(self):
		return self._displayPlaytimeOn
	
	def isPlaytimeAsMinutes(self):
		return self._displayPlaytimeAsMinutes

	def readValues(self):
		self._displayOn = getSettingBool("display.on")
		if (self._displayOn):
			self._displayBrightness = getSettingInt("display.brightness")
			self._displayChannelOn = getSettingBool("display.channel")
			if (self._displayChannelOn):
				self._displayChannelTimeout = getSettingInt("display.timeout")
			else:
				self._displayChannelTimeout = 3
			self._displayPlaytimeOn = getSettingBool("display.playtime")
			if (self._displayPlaytimeOn):
				self._displayPlaytimeAsMinutes = getSettingBool("display.minutes")
			else:
				self._displayPlaytimeAsMinutes = True
		else:
			self.__initDefaultValues()

	def __initDefaultValues(self):
		if not (self._displayOn):
			self._displayBrightness = 7
			self._displayChannel = True
			self._displayChannelTimeout = 3
			self._displayPlaytimeOn = False
